#include "fdf.h"

void	vec_mat_mult(t_mat4 *m, t_vec *v, t_pnt *result)
{
	double	x;
	double	y;

	x = v->x * m->mx[0][0] + v->y * m->mx[1][0] + v->z * m->mx[2][0] +
		m->mx[3][0];
	y = v->x * m->mx[0][1] + v->y * m->mx[1][1] + v->z * m->mx[2][1] +
		m->mx[3][1];

	result->x = (int)x;
	result->y = (int)y;
}

t_mat4	*mat4_mult(t_mat4 *m1, t_mat4 *m2)
{
	t_mat4	*m3;
	int 	i;
	int 	j;

	i = 0;
	if ((m3 = (t_mat4 *)malloc(sizeof(t_mat4))))
	{
		while(i < 4)
		{
			j = 0;
			while (j < 4)
			{
				m3->mx[i][j] = m1->mx[i][0] * m2->mx[0][j] +
							   m1->mx[i][1] * m2->mx[1][j] +
							   m1->mx[i][2] * m2->mx[2][j] +
							   m1->mx[i][3] * m2->mx[3][j];
				j++;
			}
			i++;
		}
	}
	return (m3);
}