#include "fdf.h"

void	parse_input(int ac, char **av)
{
	if (ac == 2 && ft_strstr(av[1], "--help"))
	{
		print_help();
	}
	if (ac == 4 && ft_strstr(av[1], "--heatmap"))
	{

	}
}

int		main(int argc, char **argv)
{
	t_FDF	*FDF;

	if (argc < 2 && argc > 4)
	{
		print_help();
		return (0);
	}
	else if (argc < 4)
	{
		parse_input(argc, argv);
	}
	FDF = FDF_init(argv[1]);
	center(FDF->map);
	FDF->map->trnsf = initial_trnsf_mats(FDF);
	viewport_projection_translate(FDF->map->trnsf);
	mat4_mult_chain(FDF);
	transform(FDF->map->trnsf->fin, FDF->map);
	render(FDF);
	mlx_hook(FDF->mw->win, 2, 5, key_hook, FDF);
	mlx_loop(FDF->mw->mlx);
	return (0);
}
